#include <stdio.h>
#include "fab.h"
#include "fab_rpneval.h"
#include "fabx_rpn.h"
#include "dyn_string.h"


int main(int argc, char **argv) {
/*	char buffer[BUFFER_SIZE];*/

	Dynamic_str buffer;
	FAB value;
	int contains_if_iff, no_of_gen=0;
	char *pom;

	if (argc<2) {
		fprintf(stderr, "Usage: %s \"<formula>\"\n", argv[0]);
		return 1;
	}

	init_string(&buffer);

	if (!to_RPN_ver5_autodetect(argv[1],&no_of_gen, &buffer)) {
		if (no_of_gen>0) {
			fprintf(stderr, "Error: No commutative variable (c) can be present.\n");
			release_string(&buffer);
			return 0;
		}
		printf("No.of.gen: %c\n",buffer.str[0]);
		printf("RPN: %s\n", &buffer.str[1]);	
		/* check whether contains if or iff */
		contains_if_iff=0;
		pom=buffer.str;
		while (*pom && *(pom+1)) {
			if (*pom=='i' && *(pom+1)=='f') {
				contains_if_iff=1;
				break;
			}
			pom++;
		}

		contains_if_iff = 1-contains_if_iff;
		value=eval_RPN_ver3(buffer.str, contains_if_iff);
		pt_fab(value);
	}
	release_string(&buffer);
	return 0;
}

