#include <stdio.h>
#include <string.h>
#include "fabc.h"
#include "fabc_rpneval.h"
#include "fabx_rpn.h"
#include "dyn_string.h"

int main(int argc, char **argv) {
/*	char buffer[BUFFER_SIZE];*/
	Dynamic_str buffer;

	FABC value, ai, bi, ci;
	int contains_if_iff, no_of_gen=0;
	char *pom, *pom_pom;

	if (argc<2) {
		fprintf(stderr, "Usage: %s \"<formula>\" [type]\n", argv[0]);
		return 1;
	}

	init_string(&buffer);

	if (!to_RPN_ver6_autodetect(argv[1], &pom_pom, &no_of_gen, &buffer, NORMAL_MODE)) {
		if (no_of_gen>1) {
			fprintf(stderr, "Error: Only c1 (or c) commutative variable can be present.\n");
			release_string(&buffer);
			return 0;
		}
		printf("No.of.gen: %c\n", buffer.str[0]);
		printf("RPN: %s\n", &buffer.str[1]);	
		/* check whether contains if or iff */
		contains_if_iff=0;
		pom=buffer.str;
		while (*pom && *(pom+1)) {
			if (*pom=='i' && *(pom+1)=='f') {
				contains_if_iff=1;
				break;
			}
			pom++;
		}

		/* convert value to eval_as_rel */
		contains_if_iff = 1-contains_if_iff;

		if (argc<3) {
			value=eval_RPN_fabc_ver3(buffer.str, contains_if_iff);
		}
		else {
			ai=Ac; bi=Bc, ci=Cc;
			if (!strcmp(argv[2], "abc")) {
			} else 
			if (!strcmp(argv[2], "acb")) {
				bi=Cc; ci=Bc;
			} else
			if (!strcmp(argv[2], "bac")) {
				ai=Bc; bi=Ac; 
			} else
			if (!strcmp(argv[2], "bca")) {
				ai=Cc; bi=Ac; ci=Bc;
			} else 
			if (!strcmp(argv[2], "cab")) {
				ai=Bc; bi=Cc; ci=Ac;
			} else
			if (!strcmp(argv[2], "cba")) {
				ai=Cc; ci=Ac;
			} else {
				fprintf(stderr, "\nWarning: Unknown type.\n Should be one of the abc, acb, bac, bca, cab, cba.\n Using default: abc\n");
			}
			value=eval_RPN_fabc_in_ver3(buffer.str, ai, bi, ci, contains_if_iff);
		}
		ptb_fabc(value);
	}
	
	release_string(&buffer);

	return 0;
}

