#ifndef _FAB_DYNSTACK_H_
#define _FAB_DYNSTACK_H_

#include "fab.h"

typedef struct _fab_list {
	FAB element;
	int semantic_value;
	struct _fab_list *next;
}
FAB_LIST;

typedef struct {
	FAB_LIST *bottom, *top;
} DYNSTACK_FAB;

void init_dynstack_fab(DYNSTACK_FAB *st); 
int is_empty_dynstack_fab(DYNSTACK_FAB *st);
int push_dynstack_fab(DYNSTACK_FAB *st, FAB element); 
int push_dynstack_with_value_fab(DYNSTACK_FAB *st, FAB element, int value); 
int pop_dynstack_fab(DYNSTACK_FAB *st, FAB *element); 
int pop_dynstack_with_value_fab(DYNSTACK_FAB *st, FAB *element, int *value); 
void flush_dynstack_fab(DYNSTACK_FAB *st);

/* NEW_DYN_STACK*/
typedef enum {FAB_TYPE, INT_TYPE} t_element_type;

typedef union {
	FAB f_element;
	int i_element;
} t_stack_element;

typedef struct _new_fab_list {
	t_stack_element el;
	t_element_type element_type;
	struct _new_fab_list *next;	
} NEW_FAB_LIST;

typedef struct {
	NEW_FAB_LIST *bottom, *top;
} NEW_DYNSTACK_FAB;


void init_new_dynstack_fab(NEW_DYNSTACK_FAB *st); 
int is_empty_new_dynstack_fab(NEW_DYNSTACK_FAB *st); 

int push_new_dynstack_fab(NEW_DYNSTACK_FAB *st, t_stack_element *el, t_element_type type); 
int push_int_new_dynstack_fab(NEW_DYNSTACK_FAB *st, int i_el);
int push_fab_new_dynstack_fab(NEW_DYNSTACK_FAB *st, FAB f_el); 

int pop_new_dynstack_fab(NEW_DYNSTACK_FAB *st, t_stack_element *el, t_element_type *type); 
int pop_int_new_dynstack_fab(NEW_DYNSTACK_FAB *st, int *value);
int pop_fab_new_dynstack_fab(NEW_DYNSTACK_FAB *st, FAB *value);

void flush_new_dynstack_fab(NEW_DYNSTACK_FAB *st); 
#endif
