#ifndef _FAB_PARSER_H_
#define _FAB_PARSER_H_

#include "fab.h"
#include "optype.h"
#include "fab_dynstack.h"
#include "fn_type.h"

#define BUFFER_SIZE	128


typedef FAB (*FAB_OP)();
typedef struct  {
	OPTYPE elem;
	t_fun_type f_type;
/*	int arity;*/
	FAB (*fun)();
} R_ELEM_FAB;

/* Internal */
#if 0
FAB_OP find_fun(OPTYPE el, int *arity); 
#endif
FAB_OP new_find_fun(OPTYPE el, t_fun_type *f_type);
void evaluate_nullary_fab(DYNSTACK_FAB *fab, FAB (*op)()); 
void evaluate_unary_fab(DYNSTACK_FAB *fab, FAB (*op)(FAB)); 
void evaluate_binary_fab(DYNSTACK_FAB *fab, FAB (*op)(FAB, FAB)); 
void evaluate_binary_with_int_fab(DYNSTACK_FAB *fab, FAB (*op)(FAB, FAB, int), int param); 

/* Eval */
FAB eval_RPN_ver3(char *rpn, int eval_as_rel); 
FAB eval_RPN_in_ver3(char *rpn, FAB ai, FAB bi, int eval_as_rel); 
#endif
