#ifndef _FABC_DYNSTACK_H_
#define _FABC_DYNSTACK_H_

#include "fabc.h"

typedef struct _fabc_list {
	FABC element;
	struct _fabc_list *next;
}
FABC_LIST;

typedef struct {
	FABC_LIST *bottom, *top;
} DYNSTACK_FABC;

void init_dynstack_fabc(DYNSTACK_FABC *st); 
int is_empty_dynstack_fabc(DYNSTACK_FABC *st);
int push_dynstack_fabc(DYNSTACK_FABC *st, FABC element); 
int pop_dynstack_fabc(DYNSTACK_FABC *st, FABC *element); 
void flush_dynstack_fabc(DYNSTACK_FABC *st);

/* NEW_DYN_STACK*/
typedef enum {FABC_TYPE, INT_TYPE} t_element_type_fabc;

typedef union {
	FABC fc_element;
	int   i_element;
} t_stack_element_fabc;

typedef struct _new_fabc_list {
	t_stack_element_fabc el;
	t_element_type_fabc element_type;
	struct _new_fabc_list *next;	
} NEW_FABC_LIST;

typedef struct {
	NEW_FABC_LIST *bottom, *top;
} NEW_DYNSTACK_FABC;


void init_new_dynstack_fabc(NEW_DYNSTACK_FABC *st); 
int is_empty_new_dynstack_fabc(NEW_DYNSTACK_FABC *st); 

int push_new_dynstack_fabc(NEW_DYNSTACK_FABC *st, t_stack_element_fabc *el, t_element_type_fabc type); 
int push_int_new_dynstack_fabc(NEW_DYNSTACK_FABC *st, int i_el);
int push_fabc_new_dynstack_fabc(NEW_DYNSTACK_FABC *st, FABC fc_el); 

int pop_new_dynstack_fabc(NEW_DYNSTACK_FABC *st, t_stack_element_fabc *el, t_element_type_fabc *type); 
int pop_int_new_dynstack_fabc(NEW_DYNSTACK_FABC *st, int *value);
int pop_fabc_new_dynstack_fabc(NEW_DYNSTACK_FABC *st, FABC *value);

void flush_new_dynstack_fabc(NEW_DYNSTACK_FABC *st); 

#endif
