#ifndef _FAB_PARSER_H_
#define _FAB_PARSER_H_

#include "fabc.h"
#include "optype.h"
#include "fabc_dynstack.h"
#include "fn_type.h"

#define BUF_SIZE	128
#define STACK_SIZE	512

typedef FABC (*FABC_OP)();
typedef struct  {
	OPTYPE elem;
	t_fun_type f_type;
	/*
	int arity;*/
	FABC (*fun)();
} R_ELEM_FABC;

/*Internal*/
FABC_OP find_fun_fabc(OPTYPE el, int *arity); 
void evaluate_nullary_fabc(DYNSTACK_FABC *fab, FABC (*op)()); 
void evaluate_unary_fabc(DYNSTACK_FABC *fab, FABC (*op)(FABC)); 
void evaluate_binary_fabc(DYNSTACK_FABC *fab, FABC (*op)(FABC, FABC)); 
void evaluate_binary_with_int_fabc(DYNSTACK_FABC *fab, FABC (*op)(FABC, FABC, int), int parm); 

/*Eval*/
FABC eval_RPN_fabc_ver3(char *rpn, int eval_as_rel); 
FABC eval_RPN_fabc_in_ver3(char *rpn, FABC ai, FABC bi, FABC ci, int eval_as_rel);

#endif
