#ifndef _FABN_H_
#define _FABN_H_

#include "fab.h"

typedef struct {
	FAB *fabn;
	int n;
} FABN;

int exp2(int n); 
int create_fabn(FABN *f, int n);
void clear_fabn(FABN *f);
int is_bool_fabn(FABN *f); 
void addapt_bool_fabn(int bool, FABN *f_acc); 
void T_fabn(FABN *f); /* True constant */
void F_fabn(FABN *f); /* False constant */
void O_fabn(FABN *f); /* Zero constant */
void A_fabn(FABN *f); /* Variable a constant */
void B_fabn(FABN *f); /* Variable b constant */
void Ci_fabn(FABN *f, int ith); /* Variable C_i constant */
void I_fabn(FABN *f); /* Unit constant */
void forall_bin_fabn(FABN *f_acc, FABN *f_op, FAB (*fun)(FAB,FAB)); 
void load_fabn(FABN *f_acc, FABN *f_op); 
void c_fabn(FABN *f_acc); 
void j_fabn(FABN *f_acc, FABN *f_op); 
void m_fabn(FABN *f_acc, FABN *f_op); 
void sj_fabn(FABN *f_acc, FABN *f_op); 
void sm_fabn(FABN *f_acc, FABN *f_op); 
void sp_fabn(FABN *f_acc, FABN *f_op); 
void C_rs_fabn(FABN *f_acc, FABN *f_op); 
void C_f_fabn(FABN *f1, FABN *f2, FABN *f_acc); 
void D_rs_fabn(FABN *f_acc, FABN *f_op); 
void D_f_fabn(FABN *f1, FABN *f2, FABN *f_acc); 
void imp0_fabn(FABN *f_acc, FABN *f_op); 
void imp1_fabn(FABN *f_acc, FABN *f_op); 
void imp2_fabn(FABN *f_acc, FABN *f_op); 
void imp3_fabn(FABN *f_acc, FABN *f_op); 
void imp4_fabn(FABN *f_acc, FABN *f_op); 
void imp5_fabn(FABN *f_acc, FABN *f_op); 
void lc_fabn(FABN *f_acc, FABN *f_op);
void uc_fabn(FABN *f_acc, FABN *f_op);
void pt_fabn(FABN *f); 
void ptb_fabn(FABN *f); 
void tex_fabn(FABN *f);
void pr_fabn(FABN *f); 
void beran_fabn(FABN *f);

int is_eq_fabn(FABN *f1, FABN *f2);
void is_eq_f_fabn(FABN *f1, FABN *f2, FABN *f_acc); 
int is_eq_inter_fabn(FABN *f1, FABN *f2, FABN *interpretation); 
void is_eq_inter_f_fabn(FABN *f1, FABN *f2, FABN *interpretation, FABN* f_acc); 

int is_leq_fabn(FABN *f1, FABN *f2);
void is_leq_f_fabn(FABN *f1, FABN *f2, FABN *f_acc); 
int is_leq_inter_fabn(FABN *f1, FABN *f2, FABN *interpretation); 
void is_leq_inter_f_fabn(FABN *f1, FABN *f2, FABN *interpretation, FABN* f_acc); 

#if 0
int is_lt_fabn(FABN *f1, FABN *f2);
void is_lt_f_fabn(FABN *f1, FABN *f2, FABN *f_acc); 
int is_lt_inter_fabn(FABN *f1, FABN *f2, FABN *interpretation); 
void is_lt_inter_f_fabn(FABN *f1, FABN *f2, FABN *interpretation, FABN* f_acc); 
#endif

int is_geq_fabn(FABN *f1, FABN *f2);
void is_geq_f_fabn(FABN *f1, FABN *f2, FABN *f_acc); 
int is_geq_inter_fabn(FABN *f1, FABN *f2, FABN *interpretation); 
void is_geq_inter_f_fabn(FABN *f1, FABN *f2, FABN *interpretation, FABN* f_acc); 

#if 0
int is_gt_fabn(FABN *f1, FABN *f2); 
void is_gt_f_fabn(FABN *f1, FABN *f2, FABN *f_acc); 
int is_gt_inter_fabn(FABN *f1, FABN *f2, FABN *interpretation); 
void is_gt_inter_f_fabn(FABN *f1, FABN *f2, FABN *interpretation, FABN* f_acc); 
#endif

/* Interpretations */

void create_interpretation_eq_fabn(FABN *f1, FABN *f2, FABN *interpretation); 

void create_interpretation_leq_fabn(FABN *f1, FABN *f2, FABN *interpretation); 

void create_interpretation_geq_fabn(FABN *f1, FABN *f2, FABN *interpretation); 

void create_interpretation_C_fabn(FABN *f1, FABN *f2, FABN *interpretation); 

void create_interpretation_D_fabn(FABN *f1, FABN *f2, FABN *interpretation); 

/* Conditional operations */

void cond_eq_fabn(FABN *f_acc, FABN *f_op); 

void cond_eq_fabn_rel(FABN *f_acc, FABN *f_op, int eval_as_rel); 

void cond_leq_fabn(FABN *f_acc, FABN *f_op); 

void cond_leq_fabn_rel(FABN *f_acc, FABN *f_op, int eval_as_rel); 

void cond_geq_fabn(FABN *f_acc, FABN *f_op); 

void cond_geq_fabn_rel(FABN *f_acc, FABN *f_op, int eval_as_rel); 

void cond_C_fabn(FABN *f_acc, FABN *f_op); 

void cond_C_fabn_rel(FABN *f_acc, FABN *f_op, int eval_as_rel); 

void cond_D_fabn(FABN *f_acc, FABN *f_op); 

void cond_D_fabn_rel(FABN *f_acc, FABN *f_op, int eval_as_rel); 

void cond_and_fabn(FABN *f_acc, FABN *f_op); 

void cond_and_fabn_rel(FABN *f_acc, FABN *f_op, int eval_as_rel); 

void cond_or_fabn(FABN *f_acc, FABN *f_op); 

void cond_or_fabn_rel(FABN *f_acc, FABN *f_op, int eval_as_rel); 

void cond_if_fabn(FABN *inter_facc, FABN *inter_fop); 

void cond_iff_fabn(FABN *inter_facc, FABN *inter_fop); 

void Ber_to_MO2_fabn(int ber_val, int no_of_gen, FABN *result); 
void Ber_to_MO2_fabn_ext(int ber_val, int no_of_gen, FABN *result, FABN *arg_a, FABN *arg_b); 

#endif
