#ifndef _FABN_DYNSTACK_H_
#define _FABN_DYNSTACK_H_

#include "fabn.h"

typedef struct _fabc_list {
	FABN element;
	struct _fabc_list *next;
}
FABN_LIST;

typedef struct {
/*	int n;*/
	FABN_LIST *bottom, *top;
} DYNSTACK_FABN;

void init_dynstack_fabn(DYNSTACK_FABN *st); 
int is_empty_dynstack_fabn(DYNSTACK_FABN *st);
int push_dynstack_fabn(DYNSTACK_FABN *st, FABN *element); 
int pop_dynstack_fabn(DYNSTACK_FABN *st, FABN *element); 
void flush_dynstack_fabn(DYNSTACK_FABN *st);

/* NEW_DYN_STACK*/
typedef enum {FABN_TYPE, INT_TYPE} t_element_type_fabn;

typedef union {
	FABN fn_element;
	int   i_element;
} t_stack_element_fabn;

typedef struct _new_fabn_list {
	t_stack_element_fabn el;
	t_element_type_fabn element_type;
	struct _new_fabn_list *next;	
} NEW_FABN_LIST;

typedef struct {
	NEW_FABN_LIST *bottom, *top;
} NEW_DYNSTACK_FABN;

void init_new_dynstack_fabn(NEW_DYNSTACK_FABN *st); 
int is_empty_new_dynstack_fabn(NEW_DYNSTACK_FABN *st); 

int push_int_new_dynstack_fabn(NEW_DYNSTACK_FABN *st, int i_el); 
int push_fabn_new_dynstack_fabn(NEW_DYNSTACK_FABN *st, FABN *fn_el); 
int push_new_dynstack_fabn(NEW_DYNSTACK_FABN *st, t_stack_element_fabn *el, t_element_type_fabn type); 

int pop_int_new_dynstack_fabn(NEW_DYNSTACK_FABN *st, int *i_element);
int pop_fabn_new_dynstack_fabn(NEW_DYNSTACK_FABN *st, FABN *fn_element); 
/*int pop_new_dynstack_fabn(NEW_DYNSTACK_FABN *st, t_stack_element_fabn *el, t_element_type_fabn *type); */

void flush_new_dynstack_fabn(NEW_DYNSTACK_FABN *st); 
#endif
