#ifndef _FABN_PARSER_H_
#define _FABN_PARSER_H_

#include "fabn.h"
#include "fabn_dynstack.h"
#include "fn_type.h"

typedef void (*FABN_OP)();
typedef struct  {
	OPTYPE elem;
	t_fun_type f_type;
	FABN_OP fun;
} R_ELEM_FABN;

/*Common*/
FABN_OP find_fun_fabn(OPTYPE el, int *arity); 
int create_std_values_fabn(int no_of_comm, FABN **values); 
void clear_std_values_fabn(int no_of_comm, FABN **values); 
/*Old*/
void evaluate_nullary_fabn(DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)); 
void evaluate_unary_fabn(DYNSTACK_FABN *fab, void (*op)(FABN *)); 
void evaluate_binary_fabn(DYNSTACK_FABN *fab, void (*op)(FABN*, FABN*)); 
void evaluate_binary_with_int_fabn(DYNSTACK_FABN *fab, void (*op)(FABN*, FABN*, int), int parm); 
/*For ver.3*/
void evaluate_TYPE_fabn  (NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)); 
void evaluate_F_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)); 
void evaluate_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN *)); 
void evaluate_FF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*)); 
void evaluate_FF_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*, int), int parm); 
void evaluate_IFF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN*, FABN*, FABN*)); 
/*Ver.3*/
void eval_RPN_fabn_ver3(char *rpn, FABN *result, int eval_as_rel); 
void eval_RPN_in_fabn_ver3(char *rpn, FABN **values, FABN *result, int eval_as_rel); 
/*For ver.4*/
int new_evaluate_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)); 
int new_evaluate_F_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)); 
int new_evaluate_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN *)); 
int new_evaluate_FF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*)); 
int new_evaluate_FF_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*, int), int parm);
int new_evaluate_IFF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN*, FABN*, FABN*)); 
/*Ver.4*/
int eval_RPN_fabn_ver4(char *rpn, FABN *result, int eval_as_rel); 
int eval_RPN_in_fabn_ver4(char *rpn, FABN **values,FABN *result, int eval_as_rel); 
#endif
