#ifndef _FABX_PARSER_H_
#define _FABX_PARSER_H_

#include "optype.h"

#define PARSE_OK	 0
#define PARSE_ERROR	-1
#define	PARSE_EOF	-2

/* Maximal size of input token */
#define MAX_TOKEN_SIZE	32

typedef enum {
	SENT=-1, 
	NONE, 
	DELIM, 
	PAR, 
	ARG, 
	ARG_COMM, 
	OP1PR, 
	OP1PO, 
	OP2IN,
	FUN,
	ARG_DELIM
} OPKIND;

typedef struct {
	OPKIND elem_kind;
	OPTYPE elem_idno;
	int inv_priority; /* 0 = highest ... */
	char *input_string;
	char *rpn_string;
} P_ELEM;

extern P_ELEM parsed_elements[];

/* Internal */
void list_ambiguity(char *str); 
int find_input_ver2(char *str, OPTYPE *last_found); 
int find_rpn(char *str); 
int find_optype_idx(OPTYPE el); 
OPKIND get_opkind(OPTYPE el); 
int is_arg(OPTYPE el);
int is_arg_comm(OPTYPE el);
int is_op_unary_postfix(OPTYPE el); 

/* Parse */
int parse_next_element_fabx_ver5(char *parsed, char **endposition, OPTYPE *element); 
int parse_next_element_int(char *parser, char **endposition, int *value); 

#endif
