#ifndef _OPSTACK_H_
#define _OPSTACK_H_

#include "optype.h"

typedef struct _op_list {
	OPTYPE element;
	struct _op_list *next;
}
OP_LIST;

typedef struct {
	OP_LIST *bottom, *top;
} DYNSTACK_OP;

void init_dynstack_op(DYNSTACK_OP *st);
int is_empty_dynstack_op(DYNSTACK_OP *st);
int push_dynstack_op(DYNSTACK_OP *st, OPTYPE element);
int pop_dynstack_op(DYNSTACK_OP *st, OPTYPE *element);
void flush_dynstack_op(DYNSTACK_OP *st);

/* Dumps the content of a DYNSTACK_OP st */
void dump_dynstack_op(DYNSTACK_OP *st); 
#endif
