#include <stdio.h>
#include "fabx_parser.h"
#include "fabx_rpn.h"
#include "fabc.h"
#include "fabc_rpneval.h"

R_ELEM_FABC operations_fabc[]={
	{OP_ERR,	NONE,		NULL},
	{OP_NONE,	NONE,		NULL},
	{ARG_O,		TYPE,		(FABC (*)()) &O_fabc},
	{ARG_A,		TYPE,		(FABC (*)()) &A_fabc},
	{ARG_B,		TYPE,		(FABC (*)()) &B_fabc},
	{ARG_C,		TYPE,		(FABC (*)()) &C_fabc},
	{ARG_I,		TYPE,		(FABC (*)()) &I_fabc},
	{OP_JOIN,	FF_TYPE,	(FABC (*)()) &j_fabc},
	{OP_MEET,	FF_TYPE,	(FABC (*)()) &m_fabc},
	{OP_COMPLEMENT,	F_TYPE,		(FABC (*)()) &c_fabc},
	{OP_SKEWJOIN,	FF_TYPE,	(FABC (*)()) &sj_fabc},
	{OP_SKEWMEET,	FF_TYPE,	(FABC (*)()) &sm_fabc},
	{OP_SASAKI,	FF_TYPE,	(FABC (*)()) &sp_fabc},
	{OP_IMP0,	FF_TYPE,	(FABC (*)()) &imp0_fabc},
	{OP_IMP1,	FF_TYPE,	(FABC (*)()) &imp1_fabc},
	{OP_IMP2,	FF_TYPE,	(FABC (*)()) &imp2_fabc},
	{OP_IMP3,	FF_TYPE,	(FABC (*)()) &imp3_fabc},
	{OP_IMP4,	FF_TYPE,	(FABC (*)()) &imp4_fabc},
	{OP_IMP5,	FF_TYPE,	(FABC (*)()) &imp5_fabc},
	{OP_C,		FF_TYPE,	(FABC (*)()) &C_rs_fabc},
	{OP_D,		FF_TYPE,	(FABC (*)()) &C_rs_fabc},
	{OP_LCOM,	FF_TYPE,	(FABC (*)()) &lc_fabc},
	{OP_UCOM,	FF_TYPE,	(FABC (*)()) &uc_fabc},
	{COND_EQ__REL,	FF_I_TYPE,	(FABC (*)()) &cond_eq_fabc_rel},
	{COND_LEQ_REL,	FF_I_TYPE,	(FABC (*)()) &cond_leq_fabc_rel},
	{COND_GEQ_REL,	FF_I_TYPE,	(FABC (*)()) &cond_geq_fabc_rel},
	{COND_RC__REL,	FF_I_TYPE,	(FABC (*)()) &cond_C_fabc_rel},
	{COND_RD__REL,	FF_I_TYPE,	(FABC (*)()) &cond_D_fabc_rel},
	{OP_AND_REL,	FF_I_TYPE,	(FABC (*)()) &cond_and_fabc_rel},
	{OP_OR__REL,	FF_I_TYPE,	(FABC (*)()) &cond_or_fabc_rel},
	{OP_IF_,	FF_TYPE,	(FABC (*)()) &cond_if_fabc},
	{OP_IFF,	FF_TYPE,	(FABC (*)()) &cond_iff_fabc},
	{BER1,		I_TYPE,		(FABC (*)()) Ber_to_MO2},
	{BER3,		IFF_TYPE,	(FABC (*)()) Ber_to_MO2_ext},
	{SENT,		NONE,		NULL}	
};

#if 0
FABC_OP find_fun_fabc(OPTYPE el, int *arity) {
	int i=0;

	while (operations_fabc[i].elem!=SENT) {
		if (operations_fabc[i].elem == el) {
			*arity=operations_fabc[i].arity;
			return operations_fabc[i].fun;
		}
		i++;
	}
	return NULL;
}
#endif

FABC_OP new_find_fun_fabc(OPTYPE el, t_fun_type *f_type) {
	int i=0;

	while (operations_fabc[i].elem!=(OPTYPE)SENT) {
		if (operations_fabc[i].elem == el) {
			*f_type=operations_fabc[i].f_type;
			return operations_fabc[i].fun;
		}
		i++;
	}
	return NULL;
}

void evaluate_nullary_fabc(DYNSTACK_FABC *fab, FABC (*op)()) {
	push_dynstack_fabc(fab, (*op)());
}

void evaluate_TYPE_fabc(NEW_DYNSTACK_FABC *fab, FABC (*op)()) {
	push_fabc_new_dynstack_fabc(fab, (*op)());
}

void evaluate_unary_fabc(DYNSTACK_FABC *fab, FABC (*op)(FABC)) {
	FABC vysl, arg1;

	pop_dynstack_fabc(fab, &arg1);
	vysl = (*op)(arg1);
	push_dynstack_fabc(fab, vysl);	
}

void evaluate_F_TYPE_fabc(NEW_DYNSTACK_FABC *fab, FABC (*op)(FABC)) {
	FABC vysl, arg1;

	pop_fabc_new_dynstack_fabc(fab, &arg1);
	vysl = (*op)(arg1);
	push_fabc_new_dynstack_fabc(fab, vysl);	
}

void evaluate_I_TYPE_fabc(NEW_DYNSTACK_FABC *fab, FABC (*op)(int)) {
	FABC vysl;
	int arg1;

	pop_int_new_dynstack_fabc(fab, &arg1);
	vysl = (*op)(arg1);
	push_fabc_new_dynstack_fabc(fab, vysl);	
}



void evaluate_binary_with_int_fabc(DYNSTACK_FABC *fab, FABC (*op)(FABC, FABC, int), int parm) {
	FABC vysl,arg1, arg2;

	pop_dynstack_fabc(fab,&arg2);
	pop_dynstack_fabc(fab,&arg1);
	vysl=(*op)(arg1, arg2, parm);
	push_dynstack_fabc(fab, vysl);
}

void evaluate_FF_TYPE_fabc(NEW_DYNSTACK_FABC *fab, FABC (*op)(FABC, FABC)) {
	FABC vysl,arg1, arg2;

	pop_fabc_new_dynstack_fabc(fab,&arg2);
	pop_fabc_new_dynstack_fabc(fab,&arg1);
	vysl=(*op)(arg1, arg2);
	push_fabc_new_dynstack_fabc(fab, vysl);
}

void evaluate_FF_I_TYPE_fabc(NEW_DYNSTACK_FABC *fab, FABC (*op)(FABC, FABC, int), int parm) {
	FABC vysl,arg1, arg2;

	pop_fabc_new_dynstack_fabc(fab,&arg2);
	pop_fabc_new_dynstack_fabc(fab,&arg1);
	vysl=(*op)(arg1, arg2, parm);
	push_fabc_new_dynstack_fabc(fab, vysl);
}

void evaluate_IFF_TYPE_fabc(NEW_DYNSTACK_FABC *fab, FABC (*op)(int, FABC, FABC)) {
	int arg1;
	FABC arg2, arg3, vysl;

	pop_int_new_dynstack_fabc(fab, &arg1);
	pop_fabc_new_dynstack_fabc(fab, &arg2);
	pop_fabc_new_dynstack_fabc(fab, &arg3);
	vysl = (*op)(arg1, arg2, arg3);
	push_fabc_new_dynstack_fabc(fab, vysl);
}

FABC eval_RPN_fabc_ver3(char *rpn, int eval_as_rel) {
	return eval_RPN_fabc_in_ver3(rpn, Ac,Bc,Cc, eval_as_rel);

}

FABC eval_RPN_fabc_in_ver3(char *rpn, FABC ai, FABC bi, FABC ci, int eval_as_rel) {
	char *pom=rpn, pom_buffer[MAX_TOKEN_SIZE];
	NEW_DYNSTACK_FABC st;
	FABC vysl;
	int stat,len;

	init_new_dynstack_fabc(&st);

	if (*pom != '1') {
		fprintf(stderr,"Error: The number of generators doesn't match.\n");
		return Fc;
	}
	pom++;

	while (*pom) {
		stat=-2;len=0;
		while (*pom && stat==-2) {
			pom_buffer[len++]=*pom;pom_buffer[len]='\0';
			stat=find_rpn(pom_buffer);
			pom++;
		}
		
		switch (stat) {
			case ARG_INT:
				{
					int value=0;
					while (*pom>='0' && *pom<='9') {value=10*value+*pom-'0'; pom++;}
					pom++; /* skip_space*/
					push_int_new_dynstack_fabc(&st, value);
				}
			case ARG_A:
				push_fabc_new_dynstack_fabc(&st, ai);
				break;
			case ARG_B:
				push_fabc_new_dynstack_fabc(&st, bi);
				break;
			case ARG_C:
				push_fabc_new_dynstack_fabc(&st, ci);
				break;
			default:
					{
					t_fun_type f_type = NONE_TYPE;
					FABC_OP fun;

					fun = new_find_fun_fabc(stat, &f_type);
					switch (f_type) {
						case TYPE:
							evaluate_TYPE_fabc(&st, fun);
							break;
						case F_TYPE:
							evaluate_F_TYPE_fabc(&st, (FABC (*)(FABC)) fun);
							break;
						case I_TYPE:
							evaluate_I_TYPE_fabc(&st, (FABC (*)(int)) fun);
							break;
						case FF_TYPE:
							evaluate_FF_TYPE_fabc(&st, (FABC (*)(FABC,FABC)) fun);
							break;
						case FF_I_TYPE:
							evaluate_FF_I_TYPE_fabc(&st, (FABC (*)(FABC, FABC, int)) fun, eval_as_rel);
							break;
						case IFF_TYPE:
							evaluate_IFF_TYPE_fabc(&st, (FABC (*)(int, FABC, FABC)) fun);
							break;
						default:
							fprintf(stderr, "HEHE?\n");
							break;
					}
				}
		}
	}
	pop_fabc_new_dynstack_fabc(&st, &vysl);
	if (!is_empty_new_dynstack_fabc(&st)) {
		fprintf(stderr, "Logical error in expression.(Not all operands were used.)\n");
		flush_new_dynstack_fabc(&st);
		return Fc;
	}
	flush_new_dynstack_fabc(&st);
	return vysl;
}
