#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "fabx_parser.h"
#include "fabx_rpn.h"
#include "fabn.h"
#include "fabn_rpneval.h"


R_ELEM_FABN operations_fabn[]={

	{OP_ERR,	NONE,		NULL},
	{OP_NONE,	NONE,		NULL},
	{ARG_O,		TYPE,		(void (*)()) &O_fabn},
	{ARG_A,		TYPE,		(void (*)()) &A_fabn},
	{ARG_B,		TYPE,		(void (*)()) &B_fabn},
	{ARG_C,		TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C2,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C3,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C4,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C5,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C6,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C7,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C8,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_C9,	TYPE,		(void (*)()) &Ci_fabn},
	{ARG_I,		TYPE,		(void (*)()) &I_fabn},
	{OP_JOIN,	FF_TYPE,	(void (*)()) &j_fabn},
	{OP_MEET,	FF_TYPE,	(void (*)()) &m_fabn},
	{OP_COMPLEMENT,	F_TYPE,		(void (*)()) &c_fabn},
	{OP_SKEWJOIN,	FF_TYPE,	(void (*)()) &sj_fabn},
	{OP_SKEWMEET,	FF_TYPE,	(void (*)()) &sm_fabn},
	{OP_SASAKI,	FF_TYPE,	(void (*)()) &sp_fabn},
	{OP_IMP0,	FF_TYPE,	(void (*)()) &imp0_fabn},
	{OP_IMP1,	FF_TYPE,	(void (*)()) &imp1_fabn},
	{OP_IMP2,	FF_TYPE,	(void (*)()) &imp2_fabn},
	{OP_IMP3,	FF_TYPE,	(void (*)()) &imp3_fabn},
	{OP_IMP4,	FF_TYPE,	(void (*)()) &imp4_fabn},
	{OP_IMP5,	FF_TYPE,	(void (*)()) &imp5_fabn},
	{OP_C,		FF_TYPE,	(void (*)()) &C_rs_fabn},
	{OP_D,		FF_TYPE,	(void (*)()) &D_rs_fabn},
	{OP_LCOM,	FF_TYPE,	(void (*)()) &lc_fabn},
	{OP_UCOM,	FF_TYPE,	(void (*)()) &uc_fabn},
	{COND_EQ__REL,	FF_I_TYPE,	(void (*)()) &cond_eq_fabn_rel},
	{COND_LEQ_REL,	FF_I_TYPE,	(void (*)()) &cond_leq_fabn_rel},
	{COND_GEQ_REL,	FF_I_TYPE,	(void (*)()) &cond_geq_fabn_rel},
	{COND_RC__REL,	FF_I_TYPE,	(void (*)()) &cond_C_fabn_rel},
	{COND_RD__REL,	FF_I_TYPE,	(void (*)()) &cond_D_fabn_rel},
	{OP_IF_,	FF_TYPE,	(void (*)()) &cond_if_fabn},
	{OP_IFF,	FF_TYPE,	(void (*)()) &cond_iff_fabn},
	{OP_AND_REL,	FF_I_TYPE,	(void (*)()) &cond_and_fabn_rel},
	{OP_OR__REL,	FF_I_TYPE,	(void (*)()) &cond_or_fabn_rel},
	{BER1,		I_TYPE,		(void (*)()) &Ber_to_MO2_fabn},
	{BER3,		IFF_TYPE,	(void (*)()) &Ber_to_MO2_fabn_ext},
	{SENT,		NONE,	NULL}	
};

/*****************************************************************************/
/******************************* OLD *****************************************/
/*****************************************************************************/

#if 0 
FABN_OP find_fun_fabn(OPTYPE el, int *arity) {
	int i=0;

	while (operations_fabn[i].elem!=SENT) {
		if (operations_fabn[i].elem == el) {
			*arity=operations_fabn[i].arity;
			return operations_fabn[i].fun;
		}
		i++;
	}
	return NULL;
}
#endif 

void evaluate_nullary_fabn(DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)) {
	FABN vysl;

	create_fabn(&vysl,no_of_gen);

	(*op)(&vysl);
	push_dynstack_fabn(fab, &vysl);
	clear_fabn(&vysl);
}

void evaluate_unary_fabn(DYNSTACK_FABN *fab, void (*op)(FABN *)) {
	FABN vysl;
	int n;	

	if (!is_empty_dynstack_fabn(fab)) 
		n = fab->top->element.n;
	else {
		fprintf(stderr,"Error: Stack is empty.\n");			
		return;
	}
	
	create_fabn(&vysl,n);

	pop_dynstack_fabn(fab, &vysl);
	(*op)(&vysl);
	push_dynstack_fabn(fab,&vysl);

	clear_fabn(&vysl);
}

void evaluate_binary_fabn(DYNSTACK_FABN *fab, void (*op)(FABN*, FABN*)) {
	FABN temp,vysl;
	int n;

	if (!is_empty_dynstack_fabn(fab)) 
		n = fab->top->element.n;
	else {
		fprintf(stderr,"Error: Stack is empty.\n");			
		return;
	}

	create_fabn(&temp,n);
	create_fabn(&vysl,n);

	pop_dynstack_fabn(fab,&temp);
	pop_dynstack_fabn(fab,&vysl);
	(*op)(&vysl, &temp);
	push_dynstack_fabn(fab, &vysl);
	
	clear_fabn(&vysl);
	clear_fabn(&temp);
}

void evaluate_binary_with_int_fabn(DYNSTACK_FABN *fab, void (*op)(FABN*, FABN*, int), int parm) {
	FABN temp,vysl;
	int n;

	if (!is_empty_dynstack_fabn(fab)) 
		n = fab->top->element.n;
	else {
		fprintf(stderr,"Error: Stack is empty.\n");			
		return;
	}

	create_fabn(&temp,n);
	create_fabn(&vysl,n);

	pop_dynstack_fabn(fab,&temp);
	pop_dynstack_fabn(fab,&vysl);
	(*op)(&vysl, &temp, parm);
	push_dynstack_fabn(fab, &vysl);
	
	clear_fabn(&vysl);
	clear_fabn(&temp);
}
/*****************************************************************************/
/********************************* for ver.3 *********************************/
/*****************************************************************************/
void evaluate_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)) {
	FABN vysl;

	create_fabn(&vysl,no_of_gen);
	(*op)(&vysl);
	push_fabn_new_dynstack_fabn(fab, &vysl);
	clear_fabn(&vysl);
}

/*no_of_gen -> number of commutative variables*/
void evaluate_F_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)) {
	FABN vysl;

	create_fabn(&vysl,no_of_gen);

	pop_fabn_new_dynstack_fabn(fab, &vysl);

	(*op)(&vysl);
	push_fabn_new_dynstack_fabn(fab, &vysl);

	clear_fabn(&vysl);
}

/* specific situation: with INT argument we cannot guess number of generators, therefore we need additional int*/
void evaluate_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN *)) {
	FABN vysl;
	int value;

	create_fabn(&vysl,no_of_gen);

	pop_int_new_dynstack_fabn(fab, &value);

	(*op)(value, no_of_gen, &vysl);
	push_fabn_new_dynstack_fabn(fab, &vysl);

	clear_fabn(&vysl);
}

void evaluate_FF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*)) {
	FABN temp,vysl;

	create_fabn(&temp,no_of_gen);
	create_fabn(&vysl,no_of_gen);

	pop_fabn_new_dynstack_fabn(fab,&temp);
	pop_fabn_new_dynstack_fabn(fab,&vysl);
	(*op)(&vysl, &temp);
	push_fabn_new_dynstack_fabn(fab, &vysl);
	
	clear_fabn(&vysl);
	clear_fabn(&temp);
}

void evaluate_IFF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN*, FABN*, FABN*)) {
	FABN arg_a, arg_b, vysl;
	int arg_i;

	create_fabn(&arg_a,no_of_gen);
	create_fabn(&arg_b,no_of_gen);
	create_fabn(&vysl ,no_of_gen);

	pop_int_new_dynstack_fabn(fab, &arg_i);
	pop_fabn_new_dynstack_fabn(fab,&arg_a);
	pop_fabn_new_dynstack_fabn(fab,&arg_b);
	(*op)(arg_i, no_of_gen, &vysl, &arg_a, &arg_b);
	push_fabn_new_dynstack_fabn(fab, &vysl);
	
	clear_fabn(&vysl);
	clear_fabn(&arg_b);
	clear_fabn(&arg_a);
}

void evaluate_FF_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*, int), int parm) {
	FABN temp,vysl;

	create_fabn(&temp,no_of_gen);
	create_fabn(&vysl,no_of_gen);

	pop_fabn_new_dynstack_fabn(fab,&temp);
	pop_fabn_new_dynstack_fabn(fab,&vysl);
	(*op)(&vysl, &temp, parm);
	push_fabn_new_dynstack_fabn(fab, &vysl);
	
	clear_fabn(&vysl);
	clear_fabn(&temp);
}

/*****************************************************************************/
/********************************** for ver.4 ********************************/
/*****************************************************************************/

/* Check success of the allocation of memory */
int new_evaluate_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)) {
	FABN vysl;

	if (create_fabn(&vysl,no_of_gen)<0) return -1;

	(*op)(&vysl);
	if (push_fabn_new_dynstack_fabn(fab, &vysl)<0) {clear_fabn(&vysl); return -1;}
	clear_fabn(&vysl);
	return 0;
}


int new_evaluate_F_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN *)) {
	FABN vysl;

	if (create_fabn(&vysl,no_of_gen)<0) return -1;

	if (pop_fabn_new_dynstack_fabn(fab, &vysl)<0) {clear_fabn(&vysl); return -1;}

	(*op)(&vysl);
	if (push_fabn_new_dynstack_fabn(fab, &vysl)<0) {clear_fabn(&vysl); return -1;}

	clear_fabn(&vysl);
	return 0;
}

int new_evaluate_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN *)) {
	FABN vysl;
	int value;

	if (create_fabn(&vysl,no_of_gen)<0) {return -1;}

	if (pop_int_new_dynstack_fabn(fab, &value)<0) {clear_fabn(&vysl); return -1;}

	(*op)(value, no_of_gen, &vysl);
	if (push_fabn_new_dynstack_fabn(fab, &vysl)<0) {clear_fabn(&vysl); return -1;}

	clear_fabn(&vysl);
	return 0;
}

int new_evaluate_FF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*)) {
	FABN temp,vysl;

	if (create_fabn(&temp,no_of_gen)<0) {return -1;}
	if (create_fabn(&vysl,no_of_gen)<0) {clear_fabn(&temp);return -1;}

	if (pop_fabn_new_dynstack_fabn(fab,&temp)<0 || pop_fabn_new_dynstack_fabn(fab,&vysl)<0) {
		clear_fabn(&vysl); 
		clear_fabn(&temp); 
		return -1;
	}
	(*op)(&vysl, &temp);
	if (push_fabn_new_dynstack_fabn(fab, &vysl)<0) {clear_fabn(&vysl); clear_fabn(&temp); return -1;}
	
	clear_fabn(&vysl);
	clear_fabn(&temp);
	return 0;
}

int new_evaluate_FF_I_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(FABN*, FABN*, int), int parm) {
	FABN temp,vysl;

	if (create_fabn(&temp,no_of_gen)<0) return -1;
	if (create_fabn(&vysl,no_of_gen)<0) {clear_fabn(&temp); return -1;}

	if (pop_fabn_new_dynstack_fabn(fab,&temp)<0 ||
	    pop_fabn_new_dynstack_fabn(fab,&vysl)<0) {
		clear_fabn(&temp);
		clear_fabn(&vysl);
		return -1;
	}
	(*op)(&vysl, &temp, parm);
	if (push_fabn_new_dynstack_fabn(fab, &vysl)<0) {
		clear_fabn(&temp);
		clear_fabn(&vysl);
		return -1;
	}
	
	clear_fabn(&vysl);
	clear_fabn(&temp);
	return 0;
}

int new_evaluate_IFF_TYPE_fabn(NEW_DYNSTACK_FABN *fab, int no_of_gen, void (*op)(int, int, FABN*, FABN*, FABN*)) {
	FABN arg_a, arg_b, vysl;
	int arg_i;

	if (create_fabn(&arg_a,no_of_gen)<0) {return -1;}
	if (create_fabn(&arg_b,no_of_gen)<0) {clear_fabn(&arg_a); return -1;}
	if (create_fabn(&vysl ,no_of_gen)<0) {clear_fabn(&arg_a); clear_fabn(&arg_b); return -1;}

	if (	pop_int_new_dynstack_fabn(fab, &arg_i)<0 || 
		pop_fabn_new_dynstack_fabn(fab,&arg_a)<0 || 
		pop_fabn_new_dynstack_fabn(fab,&arg_b)<0
	) {
		clear_fabn(&vysl); 
		clear_fabn(&arg_b); 
		clear_fabn(&arg_a); 
		return -1;
	}
	(*op)(arg_i, no_of_gen, &vysl, &arg_a, &arg_b);
	if (push_fabn_new_dynstack_fabn(fab, &vysl)<0) {
		clear_fabn(&vysl); 
		clear_fabn(&arg_b); 
		clear_fabn(&arg_a); 
		return -1;
	}
	
	clear_fabn(&vysl);
	clear_fabn(&arg_b);
	clear_fabn(&arg_a);
	return 0;
}

/*****************************************************************************/
/*********************************** common **********************************/
/*****************************************************************************/

FABN_OP new_find_fun_fabn(OPTYPE el, t_fun_type *f_type) {
	int i=0;

	while (operations_fabn[i].elem!=(OPTYPE)SENT) {
		if (operations_fabn[i].elem == el) {
			*f_type=operations_fabn[i].f_type;
			return operations_fabn[i].fun;
		}
		i++;
	}
	return NULL;
}


int create_std_values_fabn(int no_of_comm, FABN **values) {
	int 	i,
		no_of_gen=no_of_comm+2;

	*values= (FABN *)malloc(no_of_gen*sizeof(FABN));
	if (values==NULL) {
		fprintf(stderr,"Could not allocate memory.");
		return -1;
	}
	
	for (i=0;i<no_of_gen;i++) 
		if (create_fabn(&(*values)[i], no_of_comm)<0) {
			int j;

			for (j=0;j<i;j++)
				clear_fabn(&(*values)[i]);
			free((void *)(*values));
			*values=NULL;
			return -1;
		}
		

	A_fabn(&(*values)[0]);
	B_fabn(&(*values)[1]);
	
	for (i=2;i<no_of_gen;i++) 
		Ci_fabn(&(*values)[i], i-1);
	

	return 0;
}

void clear_std_values_fabn(int no_of_comm, FABN **values) {
	int i;

	for (i=0;i<no_of_comm+2;i++) {
		clear_fabn(&(*values)[i]);
	}

	free((void *)(*values));	
	*values=NULL;
}

/*****************************************************************************/
/************************************ ver.3 **********************************/
/*****************************************************************************/

void eval_RPN_fabn_ver3(char *rpn, FABN *result, int eval_as_rel) {
	int no_of_comm;
	FABN *values;

	no_of_comm=rpn[0]-'0';

	if (create_std_values_fabn(no_of_comm, &values)<0) {
		F_fabn(result);
		return;
	}
	
	eval_RPN_in_fabn_ver3(rpn,&values,result, eval_as_rel);

	clear_std_values_fabn(no_of_comm, &values);
}

void eval_RPN_in_fabn_ver3(char *rpn, FABN **values,FABN *result, int eval_as_rel) {
	char *pom=rpn, pom_buffer[MAX_TOKEN_SIZE];
	NEW_DYNSTACK_FABN st;
	int stat,len;
	int no_of_comm;

#ifdef DEBUG
	fprintf(stderr, "Evaluating ... %s\n", rpn);
#endif
	init_new_dynstack_fabn(&st);

	no_of_comm=*pom-'0';

	pom++;

	while (*pom) {
		stat=-2;len=0;
		while (*pom && stat==-2) {
			pom_buffer[len++]=*pom;pom_buffer[len]='\0';
			stat=find_rpn(pom_buffer);
			pom++;
		}
		
		switch (stat) {
			case ARG_INT:
				{
					int value=0;
					while (*pom>='0' && *pom<='9') {value=10*value+*pom-'0'; pom++;}
					pom++; /* skip_space*/
					push_int_new_dynstack_fabn(&st, value);
				}
				break;
			case ARG_A:
				push_fabn_new_dynstack_fabn(&st, &(*values)[0]);
				break;
			case ARG_B:
				push_fabn_new_dynstack_fabn(&st, &(*values)[1]);
				break;
			case ARG_C:
				push_fabn_new_dynstack_fabn(&st, &(*values)[2]);
				break;
			case ARG_C2:
				push_fabn_new_dynstack_fabn(&st, &(*values)[3]);
				break;
			case ARG_C3:
				push_fabn_new_dynstack_fabn(&st, &(*values)[4]);
				break;
			case ARG_C4:
				push_fabn_new_dynstack_fabn(&st, &(*values)[5]);
				break;
			case ARG_C5:
				push_fabn_new_dynstack_fabn(&st, &(*values)[6]);
				break;
			case ARG_C6:
				push_fabn_new_dynstack_fabn(&st, &(*values)[7]);
				break;
			case ARG_C7:
				push_fabn_new_dynstack_fabn(&st, &(*values)[8]);
				break;
			case ARG_C8:
				push_fabn_new_dynstack_fabn(&st, &(*values)[9]);
				break;
			case ARG_C9:
				push_fabn_new_dynstack_fabn(&st, &(*values)[10]);
				break;
			default: { t_fun_type f_type = NONE_TYPE;
				   FABN_OP fun;

				fun = new_find_fun_fabn(stat, &f_type);
					switch (f_type) {
						case TYPE:
							evaluate_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *)) fun);
							break;
						case F_TYPE:
							evaluate_F_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *)) fun);
							break;
						case I_TYPE:
							evaluate_I_TYPE_fabn(&st, no_of_comm, (void (*)(int, int, FABN *)) fun);
							break;
						case FF_TYPE:
							evaluate_FF_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *, FABN *)) fun);
							break;
						case FF_I_TYPE:
							evaluate_FF_I_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *, FABN *, int)) fun, eval_as_rel);
							
							break;
						case IFF_TYPE:
							evaluate_IFF_TYPE_fabn(&st, no_of_comm, (void (*)(int, int, FABN *, FABN *, FABN *)) fun);
							break;
						default: 
							fprintf(stderr, "HERE?");
							break;
					}
				}
				break;
		}
	}
	pop_fabn_new_dynstack_fabn(&st, result);


	if (!is_empty_new_dynstack_fabn(&st)) {
#ifdef DEBUG
		printf("HERE?2\n");	 
		if (st.top->element_type==INT_TYPE) {printf("INT_VALUE");}
		else {printf("FABN_VALUE");}
		printf("\n");
#endif
		fprintf(stderr, "Logical error in expression.(Not all operands were used.)\n");
		F_fabn(result);
	}
	flush_new_dynstack_fabn(&st);
#ifdef DEBUG

		fprintf(stderr, "end of (eval_RPN_in_fabn_ver3)\n");	 
#endif
	
}

/*****************************************************************************/
/************************************ ver.4 **********************************/
/*****************************************************************************/

int eval_RPN_fabn_ver4(char *rpn, FABN *result, int eval_as_rel) {
	int no_of_comm, status;
	FABN *values;

	no_of_comm=rpn[0]-'0';

	if (create_std_values_fabn(no_of_comm, &values)<0) {
		F_fabn(result);
		return -1;
	}
	
	status = eval_RPN_in_fabn_ver4(rpn,&values,result, eval_as_rel);

	clear_std_values_fabn(no_of_comm, &values);
	return status;
}


int eval_RPN_in_fabn_ver4(char *rpn, FABN **values,FABN *result, int eval_as_rel) {
	char *pom=rpn, pom_buffer[MAX_TOKEN_SIZE];
	NEW_DYNSTACK_FABN st;
	int stat,len;
	int no_of_comm;

	init_new_dynstack_fabn(&st);

	no_of_comm=*pom-'0';

	pom++;

	while (*pom) {
		stat=-2;len=0;
		while (*pom && stat==-2) {
			pom_buffer[len++]=*pom;pom_buffer[len]='\0';
			stat=find_rpn(pom_buffer);
			pom++;
		}
		
		switch (stat) {
			case ARG_INT:
				{
					int value=0;
					while (*pom>='0' && *pom<='9') {value=10*value+*pom-'0'; pom++;}
					pom++; /* skip_space*/
					if (push_int_new_dynstack_fabn(&st, value)<0) {
						flush_new_dynstack_fabn(&st);
						return -1;
					}
				}
				break;
			case ARG_A:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[0])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_B:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[1])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[2])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C2:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[3])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C3:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[4])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C4:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[5])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C5:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[6])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C6:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[7])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C7:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[8])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C8:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[9])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			case ARG_C9:
				if (push_fabn_new_dynstack_fabn(&st, &(*values)[10])<0) {
					flush_new_dynstack_fabn(&st);
					return -1;
				}
				break;
			default: { 
				t_fun_type f_type = NONE_TYPE;   
				FABN_OP fun;

				fun = new_find_fun_fabn(stat, &f_type);
					switch (f_type) {
						case TYPE:
							if (new_evaluate_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *)) fun)<0) {
								flush_new_dynstack_fabn(&st);
								return -1;
							}
							break;
						case F_TYPE:
							if (new_evaluate_F_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *)) fun)<0) {
								flush_new_dynstack_fabn(&st);
								return -1;
							}
							break;
						case I_TYPE:
							if (new_evaluate_I_TYPE_fabn(&st, no_of_comm, (void (*)(int, int, FABN *)) fun)<0) {
								flush_new_dynstack_fabn(&st);
								return -1;
							}
							break;
						case FF_TYPE:
							if (new_evaluate_FF_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *, FABN *)) fun)<0) {
								flush_new_dynstack_fabn(&st);
								return -1;
							}
							break;
						case FF_I_TYPE:
							if (new_evaluate_FF_I_TYPE_fabn(&st, no_of_comm, (void (*)(FABN *, FABN *, int)) fun, eval_as_rel)<0) {
								flush_new_dynstack_fabn(&st);
								return -1;
							}	
							break;
						case IFF_TYPE:
							if (new_evaluate_IFF_TYPE_fabn(&st, no_of_comm, (void (*)(int, int, FABN *, FABN *, FABN *)) fun)<0) {
								flush_new_dynstack_fabn(&st);
								return -1;
							}
							break;
						default: 
							fprintf(stderr, "Error: Unsupported or unknown function.\n");
							flush_new_dynstack_fabn(&st);
							return -1;
							break;
					}
				}
				break;
		}
	}
	if (pop_fabn_new_dynstack_fabn(&st, result)<0) {flush_new_dynstack_fabn(&st); F_fabn(result); return -1;}


	if (!is_empty_new_dynstack_fabn(&st)) {
#ifdef DEBUG
		printf("HERE?2\n");	 
		if (st.top->element_type==INT_TYPE) {printf("INT_VALUE");}
		else {printf("FABN_VALUE");}
		printf("\n");
#endif
		fprintf(stderr, "Logical error in expression. (Not all operands were used.)\n");
		flush_new_dynstack_fabn(&st);
		F_fabn(result);
		return -1;
	}
	return 0;
}
