#include <stdio.h>
#include <string.h>
#include "fabx_parser.h"


P_ELEM parsed_elements[] = {
	/*	OPKIND		OPTYPE	  Inv_Priority	Input_String RPN_STRING */
	{	NONE,		OP_ERR,		-1,	"",	""},
	{	NONE, 		OP_NONE	, 	-1, 	"",	""},
	{	DELIM,		WS_DELIM,	-1,	"",	""},
	{	ARG,		ARG_O	,	-1,	"0",	"0"},
	{	ARG,    	ARG_A	, 	-1,	"a",	"a"},
	{	ARG,    	ARG_A	, 	-1,	"x",	"a"},
	{       ARG,		ARG_B	,	-1,	"b",	"b"},
	{       ARG,		ARG_B	,	-1,	"y",	"b"},
	{	ARG,		ARG_I	,	-1,	"1",	"1"},
	{	ARG,		ARG_INT ,	-1,	"",	"I"},
	{	PAR,		OP_LEFTPAR,	1000,	"(",	""},
	{	PAR,		OP_RIGHTPAR,	10,	")",	""},
	{	OP2IN,		OP_JOIN	,	100,	"j",	"v"},
	{	OP2IN,		OP_JOIN	,	100,	"v",	"v"},
	{	OP2IN,		OP_MEET	,	50,	"m",	"^"},
	{	OP2IN,		OP_MEET	,	50,	"^",	"^"},
	{	OP1PO,		OP_COMPLEMENT,	10,	"'",	"'"},
	{	OP2IN,		OP_SKEWJOIN,	100,	"sv",	"sv"},
	{	OP2IN,		OP_SKEWJOIN,	100,	"sj",	"sv"},
	{	OP2IN,		OP_SKEWMEET,	50,	"s^",	"s^"},
	{	OP2IN,		OP_SKEWMEET,	50,	"sm",	"s^"},
	{	OP2IN,		OP_SASAKI,	40,	"sp",	"sp"},
	{	OP2IN,		OP_IMP0,	110,	"i0",	"i0"},
	{	OP2IN,		OP_IMP1,	110,	"i1",	"i1"},
	{	OP2IN,		OP_IMP2,	110,	"i2",	"i2"},
	{	OP2IN,		OP_IMP3,	110,	"i3",	"i3"},
	{	OP2IN,		OP_IMP4,	110,	"i4",	"i4"},
	{	OP2IN,		OP_IMP5,	110,	"i5",	"i5"},
	
	{	OP2IN,		OP_C,		120,	"oC",	"oC"},
	{	OP2IN,		OP_D,		120,	"oD",	"oD"},

	{	OP2IN,		COND_RC__REL,	200,	"C",	"C"},
#if 0
	{	OP2IN,		COND_RD__REL,	200,	"rD",	"rD "},
#endif
	{	OP2IN,		COND_EQ__REL,	200,	"=",	"= "},
	{	OP2IN,		COND_LEQ_REL,	200,	"<=",	"<="},
	{	OP2IN,		COND_GEQ_REL,	200,	">=",	">="},

		/* In priority: id no of Ci */	
	{	ARG_COMM,	ARG_C,		1,	"c",	"c1"},
	{	ARG_COMM,	ARG_C,		1,	"c1",	"c1"},
	{	ARG_COMM,	ARG_C2,		2,	"c2",	"c2"},
	{	ARG_COMM,	ARG_C3,		3,	"c3",	"c3"},	
	{	ARG_COMM,	ARG_C4,		4,	"c4",	"c4"},	
	{	ARG_COMM,	ARG_C5,		5,	"c5",	"c5"},	
	{	ARG_COMM,	ARG_C6,		6,	"c6",	"c6"},	
	{	ARG_COMM,	ARG_C7,		7,	"c7",	"c7"},	
	{	ARG_COMM,	ARG_C8,		8,	"c8",	"c8"},	
	{	ARG_COMM,	ARG_C9,		9,	"c9",	"c9"},	

	{	OP2IN,		OP_IF_,		300,	"=>",	"if "},
	{	OP2IN,		OP_IFF,		300,	"<=>",	"iff"},
	{	OP2IN,		OP_AND_REL,	250,	"AND",	"A"},
	{	OP2IN,		OP_OR__REL,	275,	"OR",	"O"},
	{	OP2IN,		OP_LCOM,	40,	"lc",	"lc"},
	{	OP2IN,		OP_UCOM,	40,	"uc",	"uc"},
	{	FUN,		BER1,		-1,	"B1",	"B1"},
	{	FUN,		BER3,		-1,	"B3",	"B3"},
	{	ARG_DELIM,	COMMA,		-1,	",",	""  },
		/* Sentinel */
	{	SENT,		OP_NONE,	0,	NULL,	NULL},
};

void list_ambiguity(char *str) {
	int i=0,st,stn;


	fprintf(stderr, "Error: After `%s` is/are only expected:\n", str);
	while (parsed_elements[i].elem_kind!=SENT) {
		st=strcmp(str,parsed_elements[i].input_string);
		stn=strncmp(str,parsed_elements[i].input_string,strlen(str));

		if (st<0 && stn==0) {
			fprintf(stderr,"\t %s\n", parsed_elements[i].input_string);
		}
		i++;
	}
}

int find_input_ver2(char *str, OPTYPE *last_found) {
	int i=0, no_of_found=0, st=0,stn, last=-1, new_st=0;

#ifdef DEBUG
	fprintf(stderr,"FIND_INPUT: Parsing: `%s`\n", str);
#endif
	while (parsed_elements[i].elem_kind!=SENT) {
		st=strcmp(str,parsed_elements[i].input_string);
		stn=strncmp(str,parsed_elements[i].input_string,strlen(str));

		if (st<0 && stn==0) {
			no_of_found++;
			new_st=-1;
#ifdef DEBUG
			fprintf(stderr,"found_prefix: %s\n", parsed_elements[i].input_string);
#endif
		}
		if (!st) {
#ifdef DEBUG
			fprintf(stderr,"found_total: %s\n", parsed_elements[i].input_string);
#endif
			no_of_found++;
			last=parsed_elements[i].elem_idno;
			*last_found=last;
		}
		i++;
	}

#ifdef DEBUG
	printf("NO_OF_FOUND: %d\n", no_of_found);
#endif
	/* no token found */
	if (!no_of_found) 
		return -1;
		
	/* more than one token was found */
	if (no_of_found>1) return -2;

	/* precisely one token was found, but was not complete */
	if (no_of_found == 1 && new_st<0) return -2;

	/* precisely one token was found */
	return *last_found;
}


int find_rpn(char *str) {
	int i=0,no_of_found=0, st,stn;

	while (parsed_elements[i].elem_kind!=SENT) {
		st=strcmp(str,parsed_elements[i].rpn_string);
		stn=strncmp(str,parsed_elements[i].rpn_string,strlen(str));

		if (st<0 && stn==0)
			no_of_found++;
		if (!st)
			return parsed_elements[i].elem_idno;
		i++;
	}
	if (!no_of_found) 
		return -1;
	
	return -2;
}

int find_optype_idx(OPTYPE el) {
	int i=0;

	while (parsed_elements[i].elem_kind!=SENT) {
		if (parsed_elements[i].elem_idno==el) return i;
		i++;
	}
	return -1;
}

OPKIND get_opkind(OPTYPE el) {
	return parsed_elements[find_optype_idx(el)].elem_kind;
}

int is_arg(OPTYPE el) {
	return parsed_elements[find_optype_idx(el)].elem_kind==ARG;
}

int is_arg_comm(OPTYPE el) {
	return parsed_elements[find_optype_idx(el)].elem_kind==ARG_COMM;
}

int is_op_unary_postfix(OPTYPE el) {
	return parsed_elements[find_optype_idx(el)].elem_kind==OP1PO;
}

int parse_next_element_int(char *parser, char **endposition, int *value) {
	char *pom=parser, *pom_pom;
	int val=0;

	while (*pom == '\t' || *pom == ' ') pom++;
	pom_pom = pom;
	while (*pom>='0' && *pom<='9') {val=10*val+(*pom-'0'); pom++;}
	if (pom_pom==pom) {
		fprintf(stderr, "Error: Integer argument expected.\n");
		return PARSE_ERROR;
	}
	*endposition=pom;
	*value = val;
	return PARSE_OK;
}

int parse_next_element_fabx_ver5(char *parsed, char **endposition, OPTYPE *element) {
	char *pom=parsed, pom_buffer[32];
	int len=0,st,was_ambiguous;
	OPTYPE candidate=-1;

	while (*pom == '\t' || *pom == ' ') pom++;
	if (!*pom) {
		*element=OP_NONE;
		*endposition=pom;
		return PARSE_EOF;
	}

	st = -2; candidate=-1;was_ambiguous=0;

	while (*pom && st==-2) {
#ifdef DEBUG
		fprintf(stderr, "PARSE_NEXT_FABX: %s\n", pom);
#endif
		pom_buffer[len++]=*pom;pom_buffer[len]='\0';
#ifdef DEBUG
		fprintf(stderr, "POM_BUFFER: %s\n", pom_buffer);
#endif
		st = find_input_ver2(pom_buffer,&candidate);
#ifdef DEBUG
		fprintf(stderr, "st: %d", st);
#endif
		if (st==-2) was_ambiguous=-2;
		if (st==-1) {
#ifdef DEBUG
			printf("HERE?\n");
#endif
			if (candidate==-1) {
				if (!was_ambiguous) {
#ifdef DEBUG
					/* DEBUG */
					fprintf(stderr,"Error: Syntax error.\n");
					/* **** */
#endif
					*element=OP_NONE;
					*endposition=pom;
					return PARSE_ERROR;
				}
				else {
#ifdef DEBUG
					/* DEBUG */
					printf("BB: %s\n", pom_buffer);
					/* *** */
#endif
					pom_buffer[--len]='\0';
#ifdef DEBUG
					/* DEBUG */
					printf("CC: %s\n", pom_buffer);
					/* *** */
#endif
					list_ambiguity(pom_buffer);
					/* --pom; */	

					*endposition=pom;
					*element=OP_NONE;
					return PARSE_ERROR;
				}
					
			}
			else {
				*element=candidate;
				*endposition=pom;
				return PARSE_OK;
			}
		}
		if (st>0) {
			pom++;
			*element=st;
			*endposition=pom;
			return PARSE_OK;
		}
		pom++;		
	}
	if (candidate==-1) {
		/* DEBUG*/
			printf("Buffer: %s\n", pom_buffer);

			fprintf(stderr,"Error: Premature end - ambiguos token.\n");
		/* ***  */
		list_ambiguity(pom_buffer);		
		*element=OP_NONE;
		*endposition=pom;
		return PARSE_ERROR;
	}
	*element=candidate;
	*endposition=pom;
	return PARSE_OK;
}
