#include <stdio.h>
#include <stdlib.h>
#include "op_dynstack.h"


void init_dynstack_op(DYNSTACK_OP *st) {

	st->bottom = (OP_LIST *)malloc(sizeof(OP_LIST));
	if (st->bottom == NULL) {
		fprintf(stderr, "Allocation error (init_dyn_stack_op)\n");
		return;
	}
	/* sentinel bottom */
	st->bottom->next = NULL;
	st->bottom->element = 0;

	st->top = st->bottom;
}

int is_empty_dynstack_op(DYNSTACK_OP *st) {
	return st->bottom==st->top;
}

int push_dynstack_op(DYNSTACK_OP *st, OPTYPE element) {

	OP_LIST *pom;

	pom = (OP_LIST *)malloc(sizeof(OP_LIST));
	if (pom == NULL) {
		fprintf(stderr, "Not enough memory: Could not allocate memory for struct OP_LIST (push_dynstack_op).\n");
		return -1;
	}	

	pom->next=st->top;
	pom->element=element;
	st->top=pom;

	return 0;
}

int pop_dynstack_op(DYNSTACK_OP *st, OPTYPE *element) {
	OP_LIST *pom;

	if (is_empty_dynstack_op(st)) {
		fprintf(stderr, "Stack is empty. (Error in the epression.)\n");
		return -1;
	}

	*element = st->top->element;
	pom=st->top->next;
	free((void *)st->top);
	st->top=pom;

	return 0;
}

void flush_dynstack_op(DYNSTACK_OP *st) {
	OPTYPE elem;

	while (!is_empty_dynstack_op(st)) 
		pop_dynstack_op(st, &elem);

	free((void *)st->bottom);
}

void dump_dynstack_op(DYNSTACK_OP *st) {
	OP_LIST *pom;

	pom = st->top;

	while (pom != st->bottom) {
		fprintf(stderr, "%d\n", pom->element);
		pom = pom->next;
	}
}
