%{
#define YYSTYPE FAB
#include "fab.h"
%}

%left 'j' 'v' "sj" "sv" "uc" "lc"
%left 'm' '^' "sm" "s^"
%left "sp" "C" "D"
%left '\''

%%

num_expr:	var			{$$ = $1;}
	|	constant		{$$ = $1;}
	|	'(' num_expr ')'	{$$ = $1;}
	|	num_expr '\''	 	{$$ = c_fab($1);}
	|	num_expr 'j' num_expr 	{$$ = j_fab($1, $2);}
	|	num_expr 'v' num_expr 	{$$ = j_fab($1, $2);}
	|	num_expr 'm' num_expr	{$$ = m_fab($1, $2);}
	|	num_expr '^' num_expr	{$$ = m_fab($1, $2);}
	|	num_expr "sj" num_expr	{$$ = sj_fab($1,$2);}
	|	num_expr "sv" num_expr	{$$ = sj_fab($1,$2);}
	|	num_expr "sm" num_expr	{$$ = sm_fab($1,$2);}
	|	num_expr "s^" num_expr	{$$ = sm_fab($1,$2);}
	|	num_expr "sp" num_expr	{$$ = sp_fab($1,$2);}
	|	num_expr "C" num_expr	{$$ = C_rs_fab($1,$2);}
	|	num_expr "D" num_expr	{$$ = D_rs_fab($1,$2);}
	|	num_expr "lc" num_expr	{$$ = lc_fab($1,$2);}
	|	num_expr "uc" num_expr	{$$ = uc_fab($1,$2);}
	;

var:		'a'	{$$ = A;}
	|	'b'	{$$ = B;}
	;
constant:	'0'	{$$ = O;}
	|	'1'	{$$ = I;}
	;
	
%%
